#version 430

in vec2 TexCoords;

out vec4 color;

uniform sampler2D textureSampler;

uniform float kernel[5] = float[] (0.227027, 0.1945946, 0.1216216, 0.054054, 0.016216);

void main()
{ 
    vec2 offset = 1.0 / textureSize(textureSampler, 0);

    vec3 value = texture(textureSampler, TexCoords).rgb * kernel[0];

    for(int i = 1; i < 5; ++i)
    {
        value += texture(textureSampler, TexCoords + vec2(offset.x * i, 0.0)).rgb * kernel[i];
        value += texture(textureSampler, TexCoords - vec2(offset.x * i, 0.0)).rgb * kernel[i];
    }

    color = vec4(value, 1.0);
}