#version 430 core
layout(location = 0) in vec3 in_position;
layout(location = 1) in vec3 in_normal;
layout(location = 2) in vec3 in_tangent;
layout(location = 3) in vec3 in_bitangent;
layout(location = 4) in vec2 in_uvmap;

out vec3 position;
out mat3 tbnMatrix;
out vec2 uvmap;

uniform mat4 modelMatrix;
uniform mat4 normalMatrix;
uniform mat4 viewProjMatrix;

void main() {
	gl_Position = viewProjMatrix * modelMatrix * vec4(in_position, 1);
	position = vec3(modelMatrix * vec4(in_position, 1));

	vec3 tangent = vec3(normalMatrix * vec4(in_tangent, 1));
	vec3 bitangent = vec3(normalMatrix * vec4(in_bitangent, 1));
	vec3 normal = vec3(normalMatrix * vec4(in_normal, 1));

	tbnMatrix = mat3(tangent, bitangent, normal);

	uvmap = in_uvmap;
}