#version 430

in vec2 TexCoords;

out vec4 color;

uniform sampler2D textureSampler;
uniform sampler2D bloomResult;
uniform float exposure;

void main()
{ 
    vec3 textureColor = texture(textureSampler, TexCoords).rgb;
    vec3 bloomColor = texture(bloomResult, TexCoords).rgb;
    
    vec3 finalColor = textureColor + bloomColor;

    // HDR tone mapping
    vec3 toneMapping = vec3(1.0) - exp(-finalColor * exposure);

    // gamma correct
    vec3 gamma = pow(toneMapping, vec3(1.0 / 2.2));

    color = vec4(gamma, 1.0);
}